/*
 *Avaliacao 1: 1s2012
 *
 * Neste codigo mostramos as amostras no fecho conexo de quatro vrtices
 *
 * Explique os argumentos da seguinte funcao para desenhar uma das amostras
 *  glVertex3f(0.1*0+0.2*1.+0.05*(-2.)+0.65*5.,0.1*0+0.2*2.+0.05*3.+0.65*5.,
 *             0.1*0+0.2*1.+0.05*4.+0.65*-8.);   
 *
 * Possiveis interacoes:
 *    rotacao em torno de x: 'x'; em torno de y: 'y'; em torno de z: 'z'
 *    reset 'r'
 *
 * Questao 2: Inclua no cdigo as amostras nos passos dados na avaliacao.
 *
 */
#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>

GLfloat spin_x=0.0, spin_y=0.0, spin_z=0.0;

void init(void)
{
   /* definir a cor em preto (0,0,0) como cor de "CLEAR" */
   glClearColor (0.0, 0.0, 0.0, 0.0);
   /* setar o tipo de tonalizacao. Ha duas alternativas
      GL_FLAT (constante) e GL_SMOOTH (interpolacao linear
      entre os vertices) */
   glShadeModel (GL_FLAT);
   /* setar o modo de renderizacao das faces. Ha tres alternativas:
      GL_POINT (somente vertices), GL_LINE (somente linhas) e GL_FILL
      (faces preenchidas) */
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   /* setar a convencao de orientacao. Ha duas alternativas: GL_CCW (anti-horario)      e GL_CW (horario) */
   glFrontFace (GL_CCW);
   /* Habilitar face culling */
   glEnable (GL_CULL_FACE);
   /* definir as faces a serem discardadas. Ha tres alternativas: GL_FRONT,
      GL_BACK e GL_FRONT_AND_BACK */
   glCullFace (GL_FRONT);
}

void display(void)
{
  double i, j, k, l;

   /* "CLEAR" o display */
   glClear (GL_COLOR_BUFFER_BIT);

   /* carregar a matriz de identidade na pilha de matriz de transformacao */
   glLoadIdentity();

   glRotatef(spin_x, 1.0 , 0., 0.);
   glRotatef(spin_y, 0.  , 1., 0.);
   glRotatef(spin_z, 0., 0., 1.0);

   /* desenhar os quatro vrtices */
   /* setar o tamanho do ponto em pixels */
   glPointSize(5.0);
   /* setar a cor de desenho em vermelho (1,0,0) */
   glColor3f (1.0, 0.0, 0.0);

   glBegin(GL_POINTS);
   glVertex3f(0.,0.,0.);
   glVertex3f(1.,2.,1.);
   glVertex3f(-2.,3.,4.);
   glVertex3f(5.,5.,-8.);
   glEnd();

   /* desenhar as amostras */
   /* setar o tamanho do ponto em pixels */
   glPointSize(2.0);
   /* setar a cor de desenho em branco (1,1,1) */
   glColor3f (1.0, 1.0, 1.0);

   // desenhar uma amostra
   glBegin(GL_POINTS);
   glVertex3f(0.1*0+0.2*1.+0.05*(-2.)+0.65*5.,0.1*0+0.2*2.+0.05*3.+0.65*5.,
              0.1*0+0.2*1.+0.05*4.+0.65*-8.);   
   /* para voc desenhar o restante das amostras */

   glEnd();

   /* forcar a execucao dos comandos enviados a OpenGL */
   glFlush ();
}

void reshape (int w, int h)
{
   /* definir o tamanha de janela no display, em pixels */
   //glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glViewport (0, 0, 500, 500);
   /* chavear para a pilha de transformacao de projecao */
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   // Volume de interesse: (-10,10,-10,10,-15.0,15.0)
   glOrtho (-10., 10., -10., 10., -15.0, 15.0);
   /* chavear para a pilha de transformacao de modelo */
   glMatrixMode (GL_MODELVIEW);
}

/* ARGSUSED1 */
void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 'x':
        /* increment +10.0 no ngulo de rotao em torno do eixo x */
	spin_x += 10.0;
        break;
      case 'y':
        /* incrementa +10.0 no ngulo de rotao em torno do eixo y */
	spin_y += 10.0;
        break;
      case 'z':
        /* increment +10.0 no ngulo de rotao em torno do eixo z */
	spin_z += 10.0;
        break;
      case 'r':
        /* reset */
	spin_x = spin_y = spin_z = 0.0;
        break;
      case 27:
         exit(0);
         return;
   }
   /* forar um evento para ativar o redesenho */
   glutPostRedisplay();
}

int main(int argc, char** argv)
{
   /* estabelecimento de comunicacao com o sistema de janela */
   glutInit(&argc, argv);
   /* setar o " visual" do display */
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   /* definir a janela */
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   /* inicializar openGL */
   init ();
   /* registrar os tratadores de eventos */
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutKeyboardFunc(keyboard);
   /* entre no modo de espera */
   glutMainLoop();
   return 0;
}
