/*
 *Avaliacao 1: 1s2012
 *
 * Neste codigo mostramos uma pirmide (branco) em torno de 
 *   um plano (vermelho).
 *
 * Possiveis interacoes:
 *    rotacao em torno de x: 'x'; em torno de y: 'y'; em torno de z: 'z'
 *    reset 'r'
 *
 * Questao 4: Inclua no cdigo o desenho de uma piramide refletida
 *    em relacao ao plano 
 *
 */
#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>

// Definica de uma pirmide
#define m 1.0

static GLfloat vdata[4][3] = {
  {0, 0, 0}, {m, 0, 0}, {0, m, 0}, {0, 0, m}
};

static GLuint vindices[4][3] = {
  {1,3,0}, {0,2,1}, {1,2,3}, {3,2,0}
};

GLfloat spin_x=0.0, spin_y=0.0, spin_z=0.0;

void init(void)
{
   /* definir a cor em preto (0,0,0) como cor de "CLEAR" */
   glClearColor (0.0, 0.0, 0.0, 0.0);
   /* setar o tipo de tonalizacao. Ha duas alternativas
      GL_FLAT (constante) e GL_SMOOTH (interpolacao linear
      entre os vertices) */
   glShadeModel (GL_FLAT);
   /* setar o modo de renderizacao das faces. Ha tres alternativas:
      GL_POINT (somente vertices), GL_LINE (somente linhas) e GL_FILL
      (faces preenchidas) */
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   /* setar a convencao de orientacao. Ha duas alternativas: GL_CCW (anti-horario)      e GL_CW (horario) */
   glFrontFace (GL_CCW);
   /* Habilitar face culling */
   glEnable (GL_CULL_FACE);
   /* definir as faces a serem discardadas. Ha tres alternativas: GL_FRONT,
      GL_BACK e GL_FRONT_AND_BACK */
   glCullFace (GL_FRONT);
}

void display(void)
{
   int i;

   /* "CLEAR" o display */
   glClear (GL_COLOR_BUFFER_BIT);

   /* carregar a matriz de identidade na pilha de matriz de transformacao */
   glLoadIdentity();

   glRotatef(spin_x, 1.0 , 0., 0.);
   glRotatef(spin_y, 0.  , 1., 0.);
   glRotatef(spin_z, 0., 0., 1.0);

   /* desenhar a piramide */
   /* setar a cor de desenho em branco (1,1,1) */
   glColor3f (1.0, 1.0, 1.0);
   for (i=0; i<4; i++) {
     glBegin(GL_POLYGON);
     glVertex3fv(&vdata[vindices[i][0]][0]);
     glVertex3fv(&vdata[vindices[i][1]][0]);
     glVertex3fv(&vdata[vindices[i][2]][0]);
     glEnd();
   }

   /* desenhar o plano de reflexao */
   glColor3f (1.0, 0.0, 0.0);
   for (i=0; i<4; i++) {
     glBegin(GL_POLYGON);
     glVertex3f(-3.,5.,-4.);
     glVertex3f(3.,-1.,-4.);
     glVertex3f(3.,-1.,4.);
     glVertex3f(-3.,5.,4.);
     glEnd();
   }

   /* desenhar a pirmide refletida */
   glColor3f (0.0, 0.0, 1.0);
   /* a ser completado por voc */

   /* forcar a execucao dos comandos enviados a OpenGL */
   glFlush ();
}

void reshape (int w, int h)
{
   /* definir o tamanha de janela no display, em pixels */
   //glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glViewport (0, 0, 500, 500);
   /* chavear para a pilha de transformacao de projecao */
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   // Volume de interesse: (-5,5,-5,5,-10.0,10.0)
   glOrtho (-5., 5., -5., 5., -10.0, 10.0);
   /* chavear para a pilha de transformacao de modelo */
   glMatrixMode (GL_MODELVIEW);
}

/* ARGSUSED1 */
void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 'x':
        /* increment +10.0 no ngulo de rotao em torno do eixo x */
	spin_x += 10.0;
        break;
      case 'y':
        /* incrementa +10.0 no ngulo de rotao em torno do eixo y */
	spin_y += 10.0;
        break;
      case 'z':
        /* increment +10.0 no ngulo de rotao em torno do eixo z */
	spin_z += 10.0;
        break;
      case 'r':
        /* reset */
	spin_x = spin_y = spin_z = 0.0;
        break;
      case 27:
         exit(0);
         return;
   }
   /* forar um evento para ativar o redesenho */
   glutPostRedisplay();
}

int main(int argc, char** argv)
{
   /* estabelecimento de comunicacao com o sistema de janela */
   glutInit(&argc, argv);
   /* setar o " visual" do display */
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   /* definir a janela */
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   /* inicializar openGL */
   init ();
   /* registrar os tratadores de eventos */
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutKeyboardFunc(keyboard);
   /* entre no modo de espera */
   glutMainLoop();
   return 0;
}
